package ch.usi.inf.sape.tracer.analyzer;

/**
 * Having run and traced a program, we can perform 
 * as many analyses as we want on the generated trace,
 * while the main process is still alive. 
 * In order to distinguish different analysis results,
 * we use an instance of this class to keep track of 
 * the analysis sessions.
 * 
 * @author reza
 *
 */
public class AnalysisSessionManager {
	
	private int nextSessionId = 1; 				//sessions start from 1, 0 is reserved for the full bytecode list
	
	public synchronized int getAndIncrementSessionId(){
		return nextSessionId ++;
	}

}
